SystemOrganization addCategory: #'Test-TP-Metaprogramacion'!

Object subclass: #MockClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Test-TP-Metaprogramacion'!

!MockClass methodsFor: 'private' stamp: 'Ariel 11/3/2013 18:27'!
removeAllMethodsNotPrivate

	|private methods|
	private := #removeAllMethodsNotPrivate.
	methods := self class selectors .
	methods reject: [ :m | m == private ].
	methods do: [ :m | self class removeSelector: m ].! !

TestCase subclass: #TestIVDelegator
	instanceVariableNames: 'mock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Test-TP-Metaprogramacion'!

!TestIVDelegator methodsFor: 'methods' stamp: 'Ariel 11/4/2013 00:19'!
before
	"This method initialize the object mock to work with this"
	
	| interface |
	mock = MockClass new.
	interface := Interface create: Set new.
	interface addUnimplementedMethod: #sayHello in: MockClass . ! !

TestCase subclass: #TestInterface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Test-TP-Metaprogramacion'!

!TestInterface methodsFor: 'tests' stamp: 'Ariel 11/3/2013 23:38'!
test_addNeededStubIn_andAddMethod2

	| interface setOfMethods |
	setOfMethods := Set new.
	setOfMethods add: #method1 ; add: #method2.
	interface := Interface create: setOfMethods .
	interface addUnimplementedMethod: #method1 in: MockClass.
	
	interface addNeededStubIn: MockClass.
	
	self should: [ MockClass canUnderstand: #method2 ].
	
	MockClass removeSelector: #method2.
	MockClass removeSelector: #method1.! !

!TestInterface methodsFor: 'tests' stamp: 'Ariel 11/3/2013 23:38'!
test_isComplaint_andReturnFalse

	|interface setOfMethods|
	setOfMethods := Set new.
	setOfMethods add: #method1 ; add: #method2.
	interface := Interface create: setOfMethods .
	interface addUnimplementedMethod: #method1 in: MockClass .

	self should: [ (interface isCompliant: MockClass) not ].
	MockClass removeSelector: #method1.! !

!TestInterface methodsFor: 'tests' stamp: 'Ariel 11/3/2013 23:33'!
test_isComplaint_andReturnTrue

	|interface setOfMethods|
	setOfMethods := Set new.
	setOfMethods add: #method1.
	interface := Interface create: setOfMethods .
	interface addUnimplementedMethod: #method1 in: MockClass .

	self should: [ interface isCompliant: MockClass ].
	MockClass removeSelector: #method1.! !

!TestInterface methodsFor: 'tests' stamp: 'Ariel 11/3/2013 23:35'!
test_isUnderstoodBy_andReturnFalse

	|interface mock setOfMethods|
	mock:= MockClass new.
	setOfMethods := Set new.
	setOfMethods add: #method1 ; add: #method2.
	interface := Interface create: setOfMethods .
	interface addUnimplementedMethod: #method1 in: MockClass . 
	
	self should: [ (interface isUnderstoodBy: mock) not]! !

!TestInterface methodsFor: 'tests' stamp: 'Ariel 11/3/2013 23:32'!
test_isUnderstoodBy_andReturnTrue

	|interface mock setOfMethods|
	mock:= MockClass new.
	setOfMethods := Set new.
	setOfMethods add: #method1.
	interface := Interface create: setOfMethods .
	interface addUnimplementedMethod: #method1 in: MockClass . 
	
	self should: [ interface isUnderstoodBy: mock ]! !
